Core Features

Advanced Features

JavaScript Data GridSaving Values

Version 36.2.0

After editing a cell, the grid normally inserts the new value into your data using the column definition field attribute. This covers the most common case, where the grid owns the data state and treats the data as mutable.

This page discusses alternatives to this approach.

Value Setters provides an alternative to using field for setting the data. Use valueSetter if you want the grid to manage the data (ie update the data inline) but you want to update in a way other than using field. This is useful if you are not using field, or somehow need to manipulate the data in another way (e.g. the data item isn't a simple key / value pair map, but contains a more complex structure).

Read Only Edit stops the grid from updating data, and relies on the application to make the update after the edit is complete. Use this if you want to manage the grid data state externally, such as in a Redux store.

Value Setter Copy Link

A Value Setter is the inverse of a Value Getter. Where the value getter allows getting values from your data using a function rather than a field, the value setter allows you to set values into your data using a function rather than specifying a field.

const gridOptions = {
    columnDefs: [
        // Option 1: using field for getting and setting the value
        { field: 'name' },

        // Options 2: using valueGetter and valueSetter - value getter used to get data
        {
            valueGetter: params => {
                return params.data.name;
            },
            valueSetter: params => {
                params.data.name = params.newValue;
                return true;
            }
        }
    ],

    // other grid options ...
}

A value setter should return true if the value was updated successfully and false if the value was not updated (including if the value was not changed). When you return true, the grid knows it must refresh the cell.

valueSetterCopy Link
string | ValueSetterFunc
Function or expression. Custom function to modify your data based off the new value for saving. Return true if the data changed.

The example below demonstrates value setters working alongside value getters (value setters are typically only used alongside value getters). Note the following:

  • All columns are editable. After an edit, the example prints the updated row data to the console to show the impact of the edit.

  • Column Name uses valueGetter to combine the values from the two attributes firstName and lastName (separated by a space) and valueSetter is used to break the value up into the two same attributes.

  • Column A uses field for both getting and setting the value. This is the simple case for comparison.

  • Column B uses valueGetter and valueSetter instead of field for getting and setting the value.

  • Column C.X and C.Y use valueGetter to get the value from an embedded object. They then use valueSetter to set the value into the embedded object while also making sure the correct structure exists (this structure creation would not happen if using field).

Read Only Edit Copy Link

Read Only Edit is a mode in the grid whereby Cell Editing will not update the data inside the grid. Instead the grid fires cellEditRequest events allowing the application to process the update request. To enable this mode, set the grid property readOnlyEdit=true.

cellEditRequestCopy Link
CellEditRequestEvent
Value has changed after editing. Only fires when readOnlyEdit=true.
const gridOptions = {
    readOnlyEdit: true,
    onCellEditRequest: event => {
        console.log('Cell Editing updated a cell, but the grid did nothing!');
        // the application should update the data somehow
    }
}

The example below has Cell Editing enabled, however the editing does nothing because readOnlyEdit=true is set. The application listens for cellEditRequest event and prints to the console. As the application does not try to update the data, the cell keeps its old value, giving the impression that editing is not working.

This next example extends the above by getting the application to update the data.

  1. The application listens for cellEditRequest and updates the Row Data.
  2. The Row Data has IDs and getRowId is implemented. This allows the grid to only refresh the desired row after new Row Data is set.

This final example is similar to before, except it uses Transactions to update the data after the edit rather than updating the whole Row Data.

After editing a cell, the grid normally inserts the new value into your data using the column definition field attribute. This covers the most common case, where the grid owns the data state and treats the data as mutable.
This page discusses alternatives to this approach.
Value Setters provides an alternative to using field for setting the data. Use valueSetter if you want the grid to manage the data (ie update the data inline) but you want to update in a way other than using field. This is useful if you are not using field, or somehow need to manipulate the data in another way (e.g. the data item isn't a simple key / value pair map, but contains a more complex structure).
Read Only Edit stops the grid from updating data, and relies on the application to make the update after the edit is complete. Use this if you want to manage the grid data state externally, such as in a Redux store.
Value Setter Copy Link
A Value Setter is the inverse of a Value Getter. Where the value getter allows getting values from your data using a function rather than a field, the value setter allows you to set values into your data using a function rather than specifying a field.
<ag-grid-angular
[columnDefs]="columnDefs"
/* other grid options ... */ />
this.columnDefs = [
// Option 1: using field for getting and setting the value
{ field: 'name' },
// Options 2: using valueGetter and valueSetter - value getter used to get data
{
valueGetter: params => {
return params.data.name;
},
valueSetter: params => {
params.data.name = params.newValue;
return true;
}
}
];A value setter should return true if the value was updated successfully and false if the value was not updated (including if the value was not changed). When you return true, the grid knows it must refresh the cell.
Function or expression. Custom function to modify your data based off the new value for saving. Return true if the data changed. |
The example below demonstrates value setters working alongside value getters (value setters are typically only used alongside value getters). Note the following:
All columns are editable. After an edit, the example prints the updated row data to the console to show the impact of the edit.
Column Name uses
valueGetterto combine the values from the two attributesfirstNameandlastName(separated by a space) andvalueSetteris used to break the value up into the two same attributes.Column A uses
fieldfor both getting and setting the value. This is the simple case for comparison.Column B uses
valueGetterandvalueSetterinstead of field for getting and setting the value.Column C.X and C.Y use
valueGetterto get the value from an embedded object. They then usevalueSetterto set the value into the embedded object while also making sure the correct structure exists (this structure creation would not happen if using field).
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
CellValueChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
ValueGetterParams,
ValueSetterParams,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
NumberEditorModule,
ClientSideRowModelModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
(cellValueChanged)="onCellValueChanged($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
headerName: "Name",
valueGetter: (params: ValueGetterParams) => {
return params.data.firstName + " " + params.data.lastName;
},
valueSetter: (params: ValueSetterParams) => {
const fullName = params.newValue || "";
const nameSplit = fullName.split(" ");
const newFirstName = nameSplit[0];
const newLastName = nameSplit[1];
const data = params.data;
if (data.firstName !== newFirstName || data.lastName !== newLastName) {
data.firstName = newFirstName;
data.lastName = newLastName;
// return true to tell grid that the value has changed, so it knows
// to update the cell
return true;
} else {
// return false, the grid doesn't need to update
return false;
}
},
},
{
headerName: "A",
field: "a",
},
{
headerName: "B",
valueGetter: (params: ValueGetterParams) => {
return params.data.b;
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
const valueChanged = params.data.b !== newVal;
if (valueChanged) {
params.data.b = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
{
headerName: "C.X",
valueGetter: (params: ValueGetterParams) => {
if (params.data.c) {
return params.data.c.x;
} else {
return undefined;
}
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
if (!params.data.c) {
params.data.c = {};
}
const valueChanged = params.data.c.x !== newVal;
if (valueChanged) {
params.data.c.x = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
{
headerName: "C.Y",
valueGetter: (params: ValueGetterParams) => {
if (params.data.c) {
return params.data.c.y;
} else {
return undefined;
}
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
if (!params.data.c) {
params.data.c = {};
}
const valueChanged = params.data.c.y !== newVal;
if (valueChanged) {
params.data.c.y = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
];
defaultColDef: ColDef = {
flex: 1,
editable: true,
};
rowData: any[] | null = getData();
onCellValueChanged(event: CellValueChangedEvent) {
console.log("Data after change is", event.data);
}
}
export function getData(): any[] {
const rowData = [];
const firstNames = ['Niall', 'John', 'Rob', 'Alberto', 'Bas', 'Dimple', 'Sean'];
const lastNames = ['Pink', 'Black', 'White', 'Brown', 'Smith', 'Smooth', 'Anderson'];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(window.agRandom() * 100),
b: Math.floor(window.agRandom() * 100),
firstName: firstNames[i % firstNames.length],
lastName: lastNames[i % lastNames.length],
c: {
x: Math.floor(window.agRandom() * 100),
y: Math.floor(window.agRandom() * 100),
},
});
}
return rowData;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Read Only Edit Copy Link
Read Only Edit is a mode in the grid whereby Cell Editing will not update the data inside the grid. Instead the grid fires cellEditRequest events allowing the application to process the update request. To enable this mode, set the grid property readOnlyEdit=true.
Value has changed after editing. Only fires when readOnlyEdit=true. |
<ag-grid-angular
[readOnlyEdit]="true"
(cellEditRequest)="onCellEditRequest($event)"
/* other grid options ... */ />
this.onCellEditRequest = event => {
console.log('Cell Editing updated a cell, but the grid did nothing!');
// the application should update the data somehow
};The example below has Cell Editing enabled, however the editing does nothing because readOnlyEdit=true is set. The application listens for cellEditRequest event and prints to the console. As the application does not try to update the data, the cell keeps its old value, giving the impression that editing is not working.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
CellEditRequestEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div class="example-header">
<span
>Example only logs cellEditRequests to the console, so edits are not
saved to the grid.</span
>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[readOnlyEdit]="true"
[rowData]="rowData"
(cellEditRequest)="onCellEditRequest($event)"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
editable: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onCellEditRequest(event: CellEditRequestEvent) {
console.log("onCellEditRequest, new value = " + event.newValue);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.example-header {
background-color: #ccaa22a9;
padding: 5px;
margin-bottom: 1rem;
border-radius: 5px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} This next example extends the above by getting the application to update the data.
- The application listens for
cellEditRequestand updates the Row Data. - The Row Data has IDs and
getRowIdis implemented. This allows the grid to only refresh the desired row after new Row Data is set.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellEditRequestEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
import { IOlympicDataWithId } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[getRowId]="getRowId"
[readOnlyEdit]="true"
[rowData]="rowData"
(cellEditRequest)="onCellEditRequest($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicDataWithId>;
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
editable: true,
};
getRowId: GetRowIdFunc = (params: GetRowIdParams) => String(params.data.id);
rowData!: IOlympicDataWithId[];
constructor(private http: HttpClient) {}
onCellEditRequest(event: CellEditRequestEvent) {
const data = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const oldItem = rowImmutableStore.find((row) => row.id === data.id);
if (!oldItem || !field) {
return;
}
const newItem = { ...oldItem };
newItem[field] = newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
rowImmutableStore = rowImmutableStore.map((oldItem) =>
oldItem.id == newItem.id ? newItem : oldItem,
);
this.gridApi.setGridOption("rowData", rowImmutableStore);
}
onGridReady(params: GridReadyEvent<IOlympicDataWithId>) {
this.gridApi = params.api;
this.http
.get<
IOlympicDataWithId[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
data.forEach((item, index) => (item.id = index));
rowImmutableStore = data;
params.api!.setGridOption("rowData", rowImmutableStore);
});
}
}
let rowImmutableStore: any[];
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicDataWithId extends IOlympicData {
id: number;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} This final example is similar to before, except it uses Transactions to update the data after the edit rather than updating the whole Row Data.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellEditRequestEvent,
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelApiModule,
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
import { IOlympicDataWithId } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[getRowId]="getRowId"
[readOnlyEdit]="true"
[rowData]="rowData"
(cellEditRequest)="onCellEditRequest($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
editable: true,
};
getRowId: GetRowIdFunc = (params: GetRowIdParams) => params.data.id;
rowData!: IOlympicDataWithId[];
constructor(private http: HttpClient) {}
onCellEditRequest(event: CellEditRequestEvent) {
const oldData = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const newData = { ...oldData };
newData[field!] = event.newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
const tx = {
update: [newData],
};
event.api.applyTransaction(tx);
}
onGridReady(params: GridReadyEvent<IOlympicDataWithId>) {
this.http
.get<
IOlympicDataWithId[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
data.forEach((item, index) => (item.id = String(index)));
this.rowData = data;
});
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicDataWithId extends IOlympicData {
id: number;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

After editing a cell, the grid normally inserts the new value into your data using the column definition field attribute. This covers the most common case, where the grid owns the data state and treats the data as mutable.
This page discusses alternatives to this approach.
Value Setters provides an alternative to using field for setting the data. Use valueSetter if you want the grid to manage the data (ie update the data inline) but you want to update in a way other than using field. This is useful if you are not using field, or somehow need to manipulate the data in another way (e.g. the data item isn't a simple key / value pair map, but contains a more complex structure).
Read Only Edit stops the grid from updating data, and relies on the application to make the update after the edit is complete. Use this if you want to manage the grid data state externally, such as in a Redux store.
Value Setter Copy Link
A Value Setter is the inverse of a Value Getter. Where the value getter allows getting values from your data using a function rather than a field, the value setter allows you to set values into your data using a function rather than specifying a field.
const [columnDefs, setColumnDefs] = useState([
// Option 1: using field for getting and setting the value
{ field: 'name' },
// Options 2: using valueGetter and valueSetter - value getter used to get data
{
valueGetter: params => {
return params.data.name;
},
valueSetter: params => {
params.data.name = params.newValue;
return true;
}
}
]);
<AgGridReact columnDefs={columnDefs} />A value setter should return true if the value was updated successfully and false if the value was not updated (including if the value was not changed). When you return true, the grid knows it must refresh the cell.
Function or expression. Custom function to modify your data based off the new value for saving. Return true if the data changed. |
The example below demonstrates value setters working alongside value getters (value setters are typically only used alongside value getters). Note the following:
All columns are editable. After an edit, the example prints the updated row data to the console to show the impact of the edit.
Column Name uses
valueGetterto combine the values from the two attributesfirstNameandlastName(separated by a space) andvalueSetteris used to break the value up into the two same attributes.Column A uses
fieldfor both getting and setting the value. This is the simple case for comparison.Column B uses
valueGetterandvalueSetterinstead of field for getting and setting the value.Column C.X and C.Y use
valueGetterto get the value from an embedded object. They then usevalueSetterto set the value into the embedded object while also making sure the correct structure exists (this structure creation would not happen if using field).
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellValueChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
ValueGetterParams,
ValueSetterParams,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextEditorModule,
NumberEditorModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
headerName: "Name",
valueGetter: (params: ValueGetterParams) => {
return params.data.firstName + " " + params.data.lastName;
},
valueSetter: (params: ValueSetterParams) => {
const fullName = params.newValue || "";
const nameSplit = fullName.split(" ");
const newFirstName = nameSplit[0];
const newLastName = nameSplit[1];
const data = params.data;
if (data.firstName !== newFirstName || data.lastName !== newLastName) {
data.firstName = newFirstName;
data.lastName = newLastName;
// return true to tell grid that the value has changed, so it knows
// to update the cell
return true;
} else {
// return false, the grid doesn't need to update
return false;
}
},
},
{
headerName: "A",
field: "a",
},
{
headerName: "B",
valueGetter: (params: ValueGetterParams) => {
return params.data.b;
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
const valueChanged = params.data.b !== newVal;
if (valueChanged) {
params.data.b = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
{
headerName: "C.X",
valueGetter: (params: ValueGetterParams) => {
if (params.data.c) {
return params.data.c.x;
} else {
return undefined;
}
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
if (!params.data.c) {
params.data.c = {};
}
const valueChanged = params.data.c.x !== newVal;
if (valueChanged) {
params.data.c.x = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
{
headerName: "C.Y",
valueGetter: (params: ValueGetterParams) => {
if (params.data.c) {
return params.data.c.y;
} else {
return undefined;
}
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
if (!params.data.c) {
params.data.c = {};
}
const valueChanged = params.data.c.y !== newVal;
if (valueChanged) {
params.data.c.y = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
editable: true,
};
}, []);
const onCellValueChanged = useCallback((event: CellValueChangedEvent) => {
console.log("Data after change is", event.data);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
onCellValueChanged={onCellValueChanged}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export function getData(): any[] {
const rowData = [];
const firstNames = ['Niall', 'John', 'Rob', 'Alberto', 'Bas', 'Dimple', 'Sean'];
const lastNames = ['Pink', 'Black', 'White', 'Brown', 'Smith', 'Smooth', 'Anderson'];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(window.agRandom() * 100),
b: Math.floor(window.agRandom() * 100),
firstName: firstNames[i % firstNames.length],
lastName: lastNames[i % lastNames.length],
c: {
x: Math.floor(window.agRandom() * 100),
y: Math.floor(window.agRandom() * 100),
},
});
}
return rowData;
}
Read Only Edit Copy Link
Read Only Edit is a mode in the grid whereby Cell Editing will not update the data inside the grid. Instead the grid fires cellEditRequest events allowing the application to process the update request. To enable this mode, set the grid property readOnlyEdit=true.
Value has changed after editing. Only fires when readOnlyEdit=true. |
const readOnlyEdit = true;
const onCellEditRequest = event => {
console.log('Cell Editing updated a cell, but the grid did nothing!');
// the application should update the data somehow
};
<AgGridReact readOnlyEdit={readOnlyEdit} onCellEditRequest={onCellEditRequest}></AgGridReact>The example below has Cell Editing enabled, however the editing does nothing because readOnlyEdit=true is set. The application listens for cellEditRequest event and prints to the console. As the application does not try to update the data, the cell keeps its old value, giving the impression that editing is not working.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
CellEditRequestEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
editable: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
const onCellEditRequest = useCallback((event: CellEditRequestEvent) => {
console.log("onCellEditRequest, new value = " + event.newValue);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="example-wrapper">
<div className="example-header">
<span>
Example only logs cellEditRequests to the console, so edits are
not saved to the grid.
</span>
</div>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
readOnlyEdit={true}
onCellEditRequest={onCellEditRequest}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.example-header {
background-color: #ccaa22a9;
padding: 5px;
margin-bottom: 1rem;
border-radius: 5px;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; This next example extends the above by getting the application to update the data.
- The application listens for
cellEditRequestand updates the Row Data. - The Row Data has IDs and
getRowIdis implemented. This allows the grid to only refresh the desired row after new Row Data is set.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellEditRequestEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicDataWithId } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
];
let rowImmutableStore: any[];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicDataWithId[]>();
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
editable: true,
};
}, []);
const getRowId = useCallback(
(params: GetRowIdParams) => String(params.data.id),
[],
);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicDataWithId[]) => {
data.forEach((item, index) => (item.id = index));
rowImmutableStore = data;
setRowData(rowImmutableStore);
});
}, []);
const onCellEditRequest = useCallback(
(event: CellEditRequestEvent) => {
const data = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const oldItem = rowImmutableStore.find((row) => row.id === data.id);
if (!oldItem || !field) {
return;
}
const newItem = { ...oldItem };
newItem[field] = newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
rowImmutableStore = rowImmutableStore.map((oldItem) =>
oldItem.id == newItem.id ? newItem : oldItem,
);
setRowData(rowImmutableStore);
},
[rowImmutableStore],
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicDataWithId>
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
getRowId={getRowId}
readOnlyEdit={true}
onGridReady={onGridReady}
onCellEditRequest={onCellEditRequest}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicDataWithId extends IOlympicData {
id: number;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} This final example is similar to before, except it uses Transactions to update the data after the edit rather than updating the whole Row Data.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellEditRequestEvent,
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicDataWithId } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelApiModule,
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicDataWithId[]>();
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
editable: true,
};
}, []);
const getRowId = useCallback((params: GetRowIdParams) => params.data.id, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicDataWithId[]) => {
data.forEach((item, index) => (item.id = String(index)));
setRowData(data);
});
}, []);
const onCellEditRequest = useCallback((event: CellEditRequestEvent) => {
const oldData = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const newData = { ...oldData };
newData[field!] = event.newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
const tx = {
update: [newData],
};
event.api.applyTransaction(tx);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicDataWithId>
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
getRowId={getRowId}
readOnlyEdit={true}
onGridReady={onGridReady}
onCellEditRequest={onCellEditRequest}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicDataWithId extends IOlympicData {
id: number;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

After editing a cell, the grid normally inserts the new value into your data using the column definition field attribute. This covers the most common case, where the grid owns the data state and treats the data as mutable.
This page discusses alternatives to this approach.
Value Setters provides an alternative to using field for setting the data. Use valueSetter if you want the grid to manage the data (ie update the data inline) but you want to update in a way other than using field. This is useful if you are not using field, or somehow need to manipulate the data in another way (e.g. the data item isn't a simple key / value pair map, but contains a more complex structure).
Read Only Edit stops the grid from updating data, and relies on the application to make the update after the edit is complete. Use this if you want to manage the grid data state externally, such as in a Redux store.
Value Setter Copy Link
A Value Setter is the inverse of a Value Getter. Where the value getter allows getting values from your data using a function rather than a field, the value setter allows you to set values into your data using a function rather than specifying a field.
<ag-grid-vue
:columnDefs="columnDefs"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
// Option 1: using field for getting and setting the value
{ field: 'name' },
// Options 2: using valueGetter and valueSetter - value getter used to get data
{
valueGetter: params => {
return params.data.name;
},
valueSetter: params => {
params.data.name = params.newValue;
return true;
}
}
];A value setter should return true if the value was updated successfully and false if the value was not updated (including if the value was not changed). When you return true, the grid knows it must refresh the cell.
Function or expression. Custom function to modify your data based off the new value for saving. Return true if the data changed. |
The example below demonstrates value setters working alongside value getters (value setters are typically only used alongside value getters). Note the following:
All columns are editable. After an edit, the example prints the updated row data to the console to show the impact of the edit.
Column Name uses
valueGetterto combine the values from the two attributesfirstNameandlastName(separated by a space) andvalueSetteris used to break the value up into the two same attributes.Column A uses
fieldfor both getting and setting the value. This is the simple case for comparison.Column B uses
valueGetterandvalueSetterinstead of field for getting and setting the value.Column C.X and C.Y use
valueGetterto get the value from an embedded object. They then usevalueSetterto set the value into the embedded object while also making sure the correct structure exists (this structure creation would not happen if using field).
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellValueChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
ValueGetterParams,
ValueSetterParams,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
NumberEditorModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
@cell-value-changed="onCellValueChanged"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
headerName: "Name",
valueGetter: (params: ValueGetterParams) => {
return params.data.firstName + " " + params.data.lastName;
},
valueSetter: (params: ValueSetterParams) => {
const fullName = params.newValue || "";
const nameSplit = fullName.split(" ");
const newFirstName = nameSplit[0];
const newLastName = nameSplit[1];
const data = params.data;
if (
data.firstName !== newFirstName ||
data.lastName !== newLastName
) {
data.firstName = newFirstName;
data.lastName = newLastName;
// return true to tell grid that the value has changed, so it knows
// to update the cell
return true;
} else {
// return false, the grid doesn't need to update
return false;
}
},
},
{
headerName: "A",
field: "a",
},
{
headerName: "B",
valueGetter: (params: ValueGetterParams) => {
return params.data.b;
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
const valueChanged = params.data.b !== newVal;
if (valueChanged) {
params.data.b = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
{
headerName: "C.X",
valueGetter: (params: ValueGetterParams) => {
if (params.data.c) {
return params.data.c.x;
} else {
return undefined;
}
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
if (!params.data.c) {
params.data.c = {};
}
const valueChanged = params.data.c.x !== newVal;
if (valueChanged) {
params.data.c.x = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
{
headerName: "C.Y",
valueGetter: (params: ValueGetterParams) => {
if (params.data.c) {
return params.data.c.y;
} else {
return undefined;
}
},
valueSetter: (params: ValueSetterParams) => {
const newVal = params.newValue;
if (!params.data.c) {
params.data.c = {};
}
const valueChanged = params.data.c.y !== newVal;
if (valueChanged) {
params.data.c.y = newVal;
}
return valueChanged;
},
cellDataType: "number",
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
editable: true,
});
const rowData = ref<any[] | null>(getData());
function onCellValueChanged(event: CellValueChangedEvent) {
console.log("Data after change is", event.data);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
onCellValueChanged,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
export function getData(): any[] {
const rowData = [];
const firstNames = ['Niall', 'John', 'Rob', 'Alberto', 'Bas', 'Dimple', 'Sean'];
const lastNames = ['Pink', 'Black', 'White', 'Brown', 'Smith', 'Smooth', 'Anderson'];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(window.agRandom() * 100),
b: Math.floor(window.agRandom() * 100),
firstName: firstNames[i % firstNames.length],
lastName: lastNames[i % lastNames.length],
c: {
x: Math.floor(window.agRandom() * 100),
y: Math.floor(window.agRandom() * 100),
},
});
}
return rowData;
}
Read Only Edit Copy Link
Read Only Edit is a mode in the grid whereby Cell Editing will not update the data inside the grid. Instead the grid fires cellEditRequest events allowing the application to process the update request. To enable this mode, set the grid property readOnlyEdit=true.
Value has changed after editing. Only fires when readOnlyEdit=true. |
<ag-grid-vue
:readOnlyEdit="true"
@cell-edit-request="onCellEditRequest"
/* other grid options ... */>
</ag-grid-vue>
this.onCellEditRequest = event => {
console.log('Cell Editing updated a cell, but the grid did nothing!');
// the application should update the data somehow
};The example below has Cell Editing enabled, however the editing does nothing because readOnlyEdit=true is set. The application listens for cellEditRequest event and prints to the console. As the application does not try to update the data, the cell keeps its old value, giving the impression that editing is not working.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
CellEditRequestEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div class="example-header">
<span>Example only logs cellEditRequests to the console, so edits are not saved to the grid.</span>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:readOnlyEdit="true"
:rowData="rowData"
@cell-edit-request="onCellEditRequest"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
editable: true,
});
const rowData = ref<IOlympicData[]>(null);
function onCellEditRequest(event: CellEditRequestEvent) {
console.log("onCellEditRequest, new value = " + event.newValue);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
onCellEditRequest,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.example-header {
background-color: #ccaa22a9;
padding: 5px;
margin-bottom: 1rem;
border-radius: 5px;
}
This next example extends the above by getting the application to update the data.
- The application listens for
cellEditRequestand updates the Row Data. - The Row Data has IDs and
getRowIdis implemented. This allows the grid to only refresh the desired row after new Row Data is set.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellEditRequestEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicDataWithId } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
let rowImmutableStore: any[];
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:getRowId="getRowId"
:readOnlyEdit="true"
:rowData="rowData"
@cell-edit-request="onCellEditRequest"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicDataWithId> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
editable: true,
});
const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) =>
String(params.data.id),
);
const rowData = ref<IOlympicDataWithId[]>(null);
function onCellEditRequest(event: CellEditRequestEvent) {
const data = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const oldItem = rowImmutableStore.find((row) => row.id === data.id);
if (!oldItem || !field) {
return;
}
const newItem = { ...oldItem };
newItem[field] = newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
rowImmutableStore = rowImmutableStore.map((oldItem) =>
oldItem.id == newItem.id ? newItem : oldItem,
);
gridApi.value!.setGridOption("rowData", rowImmutableStore);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
data.forEach((item, index) => (item.id = index));
rowImmutableStore = data;
params.api!.setGridOption("rowData", rowImmutableStore);
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
getRowId,
rowData,
onGridReady,
onCellEditRequest,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
This final example is similar to before, except it uses Transactions to update the data after the edit rather than updating the whole Row Data.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellEditRequestEvent,
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowIdFunc,
GetRowIdParams,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicDataWithId } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelApiModule,
NumberEditorModule,
TextEditorModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:getRowId="getRowId"
:readOnlyEdit="true"
:rowData="rowData"
@cell-edit-request="onCellEditRequest"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicDataWithId> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 160 },
{ field: "age" },
{ field: "country", minWidth: 140 },
{ field: "year" },
{ field: "date", minWidth: 140 },
{ field: "sport", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
editable: true,
});
const getRowId = ref<GetRowIdFunc>(
(params: GetRowIdParams) => params.data.id,
);
const rowData = ref<IOlympicDataWithId[]>(null);
function onCellEditRequest(event: CellEditRequestEvent) {
const oldData = event.data;
const field = event.colDef.field;
const newValue = event.newValue;
const newData = { ...oldData };
newData[field!] = event.newValue;
console.log("onCellEditRequest, updating " + field + " to " + newValue);
const tx = {
update: [newData],
};
event.api.applyTransaction(tx);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
data.forEach((item, index) => (item.id = String(index)));
rowData.value = data;
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
getRowId,
rowData,
onGridReady,
onCellEditRequest,
};
},
});
const app = createApp(VueExample);
app.mount("#app");